#include <iostream>

using namespace std;
int niz[200000];
int nizLista[200000];
bool DalRadi(int a, int b, int c, int d) {
    if (a <= b && b <= d)
        return false;
    if (a <= c && c <= d)
        return false;
    return true;
}
int main()
{
    int a;
    cin >> a;
    int vliste = 0;
    for (int i = 0; i < a; i++)
    {
        cin >> niz[i];
        if ((i > 0) && niz[i - 1] > niz[i]) {
            nizLista[vliste] = i;
            vliste++;
        }
    }

    int b;
    cin >> b;
    for (int i = 0; i < b; i++)
    {
        int n;
        int m;
        bool jeste = true;
        bool ispucao = false;
        cin >> n >> m;
        int br = 0;

        for (int j = 0; (j < vliste); j++)
        {
            if (nizLista[j] > m - 1) {
                break;
            }
            if (ispucao && (nizLista[j] >= n)) {
                jeste = false;
                break;
            }
            if ((nizLista[j] >= n) && !ispucao) {
                if (DalRadi(niz[nizLista[j]-2],niz[nizLista[j] -1],niz[nizLista[j]],niz[nizLista[j] +1]))
                {
                    jeste = false;
                    break;
                }
                else
                    ispucao = true;
            }
        }
        if (jeste)
            cout << "DA" << endl;
        else
            cout << "NE" << endl;

    }
}